; Autogenerated AcheronVM instruction definitions
; See acheron.asm for source

.define r0 0
.define r1 1
.define r2 2
.define r3 3
.define r4 4
.define r5 5
.define r6 6
.define r7 7
.define r8 8
.define r9 9
.define r10 10
.define r11 11
.define r12 12
.define r13 13
.define r14 14
.define r15 15

.importzp zpTop
.importzp rptr
.importzp pptr
.importzp iptr
.importzp cstack
.import clear_rstack
.import acheron
.importzp gptr
.importzp currentCatch
.import enableInstructionTrap
.import disableInstructionTrap
.import continueFromInstructionTrap
.import enableExceptionTrap
.import disableExceptionTrap
.import continueFromExceptionTrap
.importzp rstackTop

.macro addp imm
 .if (imm > 255) .or (imm < -255)
   addp16 imm
 .elseif (imm < 0)
   subp8 -(imm)
 .elseif (imm <> 0)
   addp8 imm
 .endif
.endmacro

.macro addpc imm
 .if (imm > 255) .or (imm < -255)
   addp16c imm
 .elseif (imm < 0)
   subp8c -(imm)
 .elseif (imm <> 0)
   addp8c imm
 .endif
.endmacro

.macro subp imm
 .if (imm > 255) .or (imm < -255)
   addp16 -(imm)
 .elseif (imm < 0)
   addp8 -(imm)
 .elseif (imm <> 0)
   subp8 imm
 .endif
.endmacro

.macro subpc imm
 .if (imm > 255) .or (imm < -255)
   addp16c -(imm)
 .elseif (imm < 0)
   addp8c -(imm)
 .elseif (imm <> 0)
   subp8c imm
 .endif
.endmacro

.macro rets imm
 .if (imm >= 1) .and (imm <= 16)
   rets4 imm
 .elseif (imm = 0)
   ret
 .else
   rets8 imm
 .endif
.endmacro

.macro grow imm
 .if (imm >= 1) .and (imm <= 16)
   grow4 imm
 .elseif (imm <> 0)
   grow8 imm
 .endif
.endmacro

.macro set reg, imm
 .if (imm > 255) .or (imm < 0)
   set16 reg, imm
 .elseif (imm > 0)
   set8 reg, imm
 .else
   clr reg
 .endif
.endmacro

.macro case imm, rel8
 .if (imm >= 0) .and (imm <=255)
   case8 imm, rel8
 .else
   case16 imm, rel8
 .endif
.endmacro

.define roll (rD, imm4)              .byte $00, (((rD)<<4) + (imm4))
.define shl (rD, imm4)               .byte $01, (((rD)<<4) + (imm4))
.define shr (rD, imm4)               .byte $02, (((rD)<<4) + (imm4))
.define sshr (rD, imm4)              .byte $03, (((rD)<<4) + (imm4))
.define incp2 ()                     .byte $04
.define incp ()                      .byte $05
.define addi8 (rD, imm8)             .byte $06, ((rD)<<1), (imm8)-1
.define addi4 (rD, imm4p1)           .byte $07, (((rD)<<4) + ((imm4p1) - 1))
.define addi4c (rD, imm4)            .byte $08, (((rD)<<4) + (imm4))
.define addp8c (imm8)                .byte $09, imm8
.define addp8 (imm8)                 .byte $0a, imm8
.define addp16c (imm16)              .byte $0b, <(imm16), >(imm16)
.define addp16 (imm16)               .byte $0c, <(imm16), >(imm16)
.define add (rD, rA)                 .byte $0d, (((rD)<<4) + (rA))
.define addc (rD, rA)                .byte $0e, (((rD)<<4) + (rA))
.define decp ()                      .byte $0f
.define decp2 ()                     .byte $10
.define subi (rD, imm4p1)            .byte $11, (((rD)<<4) + ((imm4p1) - 1))
.define subic (rD, imm4)             .byte $12, (((rD)<<4) + (imm4))
.define subp8c (imm8)                .byte $13, imm8
.define subp8 (imm8)                 .byte $14, imm8
.define test (rD, rA)                .byte $15, (((rD)<<4) + (rA))
.define subc (rD, rA)                .byte $16, (((rD)<<4) + (rA))
.define sub (rD, rA)                 .byte $17, (((rD)<<4) + (rA))
.define mul (rD, rA)                 .byte $18, (((rD)<<4) + (rA))
.define mac (rD, rA)                 .byte $19, (((rD)<<4) + (rA))
.define div (rD, rA)                 .byte $1a, (((rD)<<4) + (rA))
.define ldiv (rD, rA)                .byte $1b, (((rD)<<4) + (rA))
.define callp2 (rD, rA)              .byte $1c, (((rD)<<4) + (rA))
.define callp ()                     .byte $1d
.define jumpp ()                     .byte $1e
.define call2 (rD, rA, imm16)        .byte $1f, (((rD)<<4) + (rA)), <(imm16), >(imm16)
.define call (imm16)                 .byte $20, <(imm16), >(imm16)
.define jump (imm16)                 .byte $21, <(imm16), >(imm16)
.define rets4 (imm4p1)               .byte $90 + (imm4p1) - 1
.define rets8 (imm8)                 .byte $22, ((imm8)<<1)
.define ret ()                       .byte $23
.define native ()                    .byte $24
.define grow4 (imm4p1)               .byte $a0 + (imm4p1) - 1
.define grow8 (imm8)                 .byte $25, (-((imm8)<<1)) & $ff
.define dropc ()                     .byte $26
.define pushregs (rD, imm4)          .byte $27, (((rD)<<4) + (imm4))
.define popregs (rD, imm4)           .byte $28, (((rD)<<4) + (imm4))
.define clrmp ()                     .byte $29
.define clrmbp ()                    .byte $2a
.define stpmb (rD)                   .byte $2b, ((rD)<<1)
.define stpm (rD)                    .byte $2c, ((rD)<<1)
.define ldm (rD, rA)                 .byte $2d, (((rD)<<4) + (rA))
.define ldmi (rD, rA, imm8)          .byte $2e, (((rD)<<4) + (rA)), imm8
.define stm (rD, rA)                 .byte $2f, (((rD)<<4) + (rA))
.define stmi (rD, rA, imm8)          .byte $30, (((rD)<<4) + (rA)), imm8
.define nswap ()                     .byte $31
.define negatep ()                   .byte $32
.define notp ()                      .byte $33
.define andr (rD, rA)                .byte $34, (((rD)<<4) + (rA))
.define orr (rD, rA)                 .byte $35, (((rD)<<4) + (rA))
.define xorr (rD, rA)                .byte $36, (((rD)<<4) + (rA))
.define ldg (rD, imm8)               .byte $b0 + (rD), imm8
.define stgp (imm8)                  .byte $37, imm8
.define addgptr ()                   .byte $38
.define catch (imm16)                .byte $39, <(imm16), >(imm16)
.define popcatch ()                  .byte $3a
.define throw (rD, rA)               .byte $3b, (((rD)<<4) + (rA))
.define flipc ()                     .byte $3c
.define hibyte ()                    .byte $3d
.define lobyte ()                    .byte $3e
.define bswap ()                     .byte $3f
.define set8 (rD, imm8)              .byte $c0 + (rD), imm8
.define stmb (rD, rA)                .byte $40, (((rA)<<4) + (rD))
.define clr (rD)                     .byte $d0 + (rD)
.define with (rD)                    .byte $e0 + (rD)
.define noop ()                      .byte $41
.define andp (imm16)                 .byte $42, <(imm16), >(imm16)
.define orp (imm16)                  .byte $43, <(imm16), >(imm16)
.define xorp (imm16)                 .byte $44, <(imm16), >(imm16)
.define ldrptr (rD, rA)              .byte $45, (((rD)<<4) + (rA))
.define ldmb (rD, rA)                .byte $46, (((rA)<<4) + (rD))
.define copy (rD, rA)                .byte $47, (((rD)<<4) + (rA))
.define set16 (rD, imm16)            .byte $f0 + (rD), <(imm16), >(imm16)
.define bc (rel8)                    .byte $48, <((rel8) - * + 1)
.define bnc (rel8)                   .byte $49, <((rel8) - * + 1)
.define bneg (rel8)                  .byte $4a, <((rel8) - * + 1)
.define bpos (rel8)                  .byte $4b, <((rel8) - * + 1)
.define bz (rel8)                    .byte $4c, <((rel8) - * + 1)
.define bnz (rel8)                   .byte $4d, <((rel8) - * + 1)
.define ba (rel8)                    .byte $4e, <((rel8) - * + 1)
.define decloop (rD, imm4p1, rel8)   .byte $4f, (((rD)<<4) + <((imm4p1) - 1)), <((rel8) - * + 2)
.define case8 (imm8, rel8)           .byte $50, imm8, <((rel8) - * + 1)
.define case16 (imm16, rel8)         .byte $51, <(imm16), >(imm16), <((rel8) - * + 1)

.define opcode_roll                 $00
.define opcode_shl                  $01
.define opcode_shr                  $02
.define opcode_sshr                 $03
.define opcode_incp2                $04
.define opcode_incp                 $05
.define opcode_addi8                $06
.define opcode_addi4                $07
.define opcode_addi4c               $08
.define opcode_addp8c               $09
.define opcode_addp8                $0a
.define opcode_addp16c              $0b
.define opcode_addp16               $0c
.define opcode_add                  $0d
.define opcode_addc                 $0e
.define opcode_decp                 $0f
.define opcode_decp2                $10
.define opcode_subi                 $11
.define opcode_subic                $12
.define opcode_subp8c               $13
.define opcode_subp8                $14
.define opcode_test                 $15
.define opcode_subc                 $16
.define opcode_sub                  $17
.define opcode_mul                  $18
.define opcode_mac                  $19
.define opcode_div                  $1a
.define opcode_ldiv                 $1b
.define opcode_callp2               $1c
.define opcode_callp                $1d
.define opcode_jumpp                $1e
.define opcode_call2                $1f
.define opcode_call                 $20
.define opcode_jump                 $21
.define opcode_rets4                $90
.define opcode_rets8                $22
.define opcode_ret                  $23
.define opcode_native               $24
.define opcode_grow4                $a0
.define opcode_grow8                $25
.define opcode_dropc                $26
.define opcode_pushregs             $27
.define opcode_popregs              $28
.define opcode_clrmp                $29
.define opcode_clrmbp               $2a
.define opcode_stpmb                $2b
.define opcode_stpm                 $2c
.define opcode_ldm                  $2d
.define opcode_ldmi                 $2e
.define opcode_stm                  $2f
.define opcode_stmi                 $30
.define opcode_nswap                $31
.define opcode_negatep              $32
.define opcode_notp                 $33
.define opcode_andr                 $34
.define opcode_orr                  $35
.define opcode_xorr                 $36
.define opcode_ldg                  $b0
.define opcode_stgp                 $37
.define opcode_addgptr              $38
.define opcode_catch                $39
.define opcode_popcatch             $3a
.define opcode_throw                $3b
.define opcode_flipc                $3c
.define opcode_hibyte               $3d
.define opcode_lobyte               $3e
.define opcode_bswap                $3f
.define opcode_set8                 $c0
.define opcode_stmb                 $40
.define opcode_clr                  $d0
.define opcode_with                 $e0
.define opcode_noop                 $41
.define opcode_andp                 $42
.define opcode_orp                  $43
.define opcode_xorp                 $44
.define opcode_ldrptr               $45
.define opcode_ldmb                 $46
.define opcode_copy                 $47
.define opcode_set16                $f0
.define opcode_bc                   $48
.define opcode_bnc                  $49
.define opcode_bneg                 $4a
.define opcode_bpos                 $4b
.define opcode_bz                   $4c
.define opcode_bnz                  $4d
.define opcode_ba                   $4e
.define opcode_decloop              $4f
.define opcode_case8                $50
.define opcode_case16               $51


; Number of embedded opcodes:   $07
; Number of unembedded opcodes: $52
; Number of opcodes remaining:  $3e
