OP_CATEGORY globals, "Global Variables (FEATURE__GLOBALS)", "Similar to the 6502's zeropage, 256 bytes of global storage (as opposed to register stack storage) are addressable in short form."
OP_CATDOC globals, "Dereferencing through gptr allows faster context switching and reusable code between processes with different global tables."

ZPVAR gptr, globals, 2, "Pointer to the globals area.  Must be directly initialized before use."

OPE ldg, rdimm8, globals, "rD := global(imm8)"
 lda (iptr),y
 tay
 lda (gptr),y
 sta 0,x
 iny
 lda (gptr),y
 sta 1,x
 jmp mainLoop2c

;OPE stg, rdimm8, globals, "global(imm8) := rD"
OP stgp, imm8, globals, "global(imm8) := rP"
 lda (iptr),y
 tay
 lda 0,x
 sta (gptr),y
 iny
 lda 1,x
 sta (gptr),y
 jmp mainLoop2c

OP addgptr, none, globals, "rP := pointer to global(rP)"
 lda 0,x
 adc #<gptr
 sta 0,x
 lda 1,x
 adc #>gptr
 sta 1,x
 jmp mainLoop1
