PSEUDO addp, "imm", math, "Becomes addp8, addp16, or subp8.", {" .if (imm > 255) .or (imm < -255)",EOL, "   addp16 imm",EOL, " .elseif (imm < 0)",EOL, "   subp8 -(imm)",EOL, " .elseif (imm <> 0)",EOL, "   addp8 imm",EOL, " .endif"}
PSEUDO addpc, "imm", math, "Becomes addp8c, addp16c, or subp8c.", {" .if (imm > 255) .or (imm < -255)",EOL, "   addp16c imm",EOL, " .elseif (imm < 0)",EOL, "   subp8c -(imm)",EOL, " .elseif (imm <> 0)",EOL, "   addp8c imm",EOL, " .endif"}
PSEUDO subp, "imm", math, "Becomes subp8, addp16, or addp8.", {" .if (imm > 255) .or (imm < -255)",EOL, "   addp16 -(imm)",EOL, " .elseif (imm < 0)",EOL, "   addp8 -(imm)",EOL, " .elseif (imm <> 0)",EOL, "   subp8 imm",EOL, " .endif"}
PSEUDO subpc, "imm", math, "Becomes subp8c, addp16c, or addp8c.", {" .if (imm > 255) .or (imm < -255)",EOL, "   addp16c -(imm)",EOL, " .elseif (imm < 0)",EOL, "   addp8c -(imm)",EOL, " .elseif (imm <> 0)",EOL, "   subp8c imm",EOL, " .endif"}

;-------------
; Addition

OP incp2, none, math, "rP := rP + 2"
 lda 0,x
 adc #2
 sta 0,x
 bcc :++
 bcs :+
OP incp, none, math, "rP := rP + 1"
 inc 0,x
 bne :++
: inc 1,x
:jmp mainLoop1

OP addi8, rdimm8p1, math, "rD := rD + imm8 (1-256)"
 decode_rd
 iny
 lda (iptr),y
 sec
 adc 0,x
 sta 0,x
 bcc :+
  inc 1,x
  beq :+
   clc
:ror cstack
jmp mainLoop3

OP addi4, rdimm4p1, math, "rD := rD + imm4 (1-16)"
 decode_rdimm4
 sec
 bcs :+
OP addi4c, rdimm4, math, "rD := rD + imm4 + carry"
 decode_rdimm4
 asl cstack
:tya
 adc 0,x
 sta 0,x
 bcc :+
  inc 1,x
  beq :+
   clc
:ror cstack
 jmp mainLoop2

OP addp8c, imm8, math, "rP := rP + imm8 + carry"
 asl cstack
OP addp8, imm8, math, "rP := rP + imm8"
 lda 0,x
 adc (iptr),y
 sta 0,x
 bcc :+
  inc 1,x
  beq :+
   clc
:ror cstack
 jmp mainLoop2

OP addp16c, imm16, math, "rP := rP + imm16 + carry"
 asl cstack
OP addp16, imm16, math, "rP := rP + imm16"
 lda 0,x
 adc (iptr),y
 sta 0,x
 iny
 lda 1,x
 adc (iptr),y
 sta 1,x
 ror cstack
 jmp mainLoop3

OP add, rdra, math, "rD := rD + rA"
 decode_rdra
 bcc :+
OP addc, rdra, math, "rD := rD + rA + carry"
 decode_rdra
 asl cstack
:lda 0,x
 adc 0,y
 sta 0,x
 lda 1,x
 adc 1,y
 sta 1,x
 ror cstack
 jmp mainLoop2


;-------------
; Subtraction


OP decp, none, math, "rP := rP - 1"
 sec
OP decp2, none, math, "rP := rP - 2"
 lda 0,x
 adc #$fe
 sta 0,x
 bcs :+
  dec 1,x
:jmp mainLoop1

OP subi, rdimm4p1, math, "rD := rD - imm4 (1-16)"
 decode_rdimm4
 bcc :+
OP subic, rdimm4, math, "rD := rD - imm4 - borrow"
 decode_rdimm4
 asl cstack
:tya
 eor #$ff
 adc 0,x
 sta 0,x
 bcs :++
  lda 1,x
  bne :+
   sec
: inc 1,x
:ror cstack
 jmp mainLoop2

OP subp8c, imm8, math, "rP := rP - imm8 - borrow"
 asl cstack
 .byte $a9
OP subp8, imm8, math, "rP := rP - imm8"
 sec
 lda 0,x
 sbc (iptr),y
 sta 0,x
 bcs :+
  lda 1,x
  bne :++
   sec
: dec 1,x
:ror cstack
 jmp mainLoop2

OP test, rdra, math, "rH := rD - rA"
 decode_rdra
 lda 0,x
 sta 2,x
 lda 1,x
 sta 3,x
 inx
 inx
 stx pptr
 bcc :+
OP subc, rdra, math, "rD := rD - rA - borrow"
 decode_rdra
 ror cstack
 jmp :+
OP sub, rdra, math, "rD := rD - rA"
 decode_rdra
:sec
 lda 0,x
 sbc 0,y
 sta 0,x
 lda 1,x
 sbc 1,y
 sta 1,x
 ror cstack
 jmp mainLoop2

