.include "../bin/acheron.inc"

.code


.export start
start:
  jsr clear_rstack
  jsr acheron       ; Note that gptr has not been initialied, so we are not using global variables

  grow 2
  ; Print a number
  set r0, 12345
  set16 r1, cursor     ; pointer to which cursor to use
  call outputNumber

  ; all done, just sit here
: ba :-

cursor: .word $0400  ; screen memory on c64



;--------------------
.proc convertString             ; .proc is a ca65-ism, just sets a label and creates a local variable scope
; in: r0=num, r1=buf pointer
; out: r1=address of the start of the rendered string in the buffer

  grow 3
  ; some variable naming sugar.  Once I get out of ca65 preprocessing and have more powerful macros, this will probably be integrated into the function spec, or added sugar on the grow instruction
  quotient = r0
  remainder = r1
  ten = r2
  num = r3  ; caller's r0
  buf = r4  ; we're going to be directly using and modifying the caller's r1 here

  ; Add a zero terminator 6 bytes into the buffer
  addi4 buf, 5
  clrmbp

  ; Initialize loop state
  copy quotient, num     ; reposition to make room for how quotient & remainder come out of div
  set ten, 10

  ; Fill the buffer right to left, starting from the one's digit 5 bytes in
:  subi buf, 1           ; predecrement buf
   div quotient, ten     ; quotient becomes rP, but we're not testing that yet
   addi8 remainder, '0'  ; convert remainder to ascii
   stpmb buf             ; store prior byte into buf
   with quotient
  bnz :-
  rets 3  ; since the caller's r1 (buf) has been used directly, it sees the value of the pointer to the last-written byte (most significant digit)
.endproc


;--------------------
.proc outputNumber
; in: r0=num, r1=output handle

  grow 3
  buf = r2
  num  = r3 ; caller's r0
  handle = r4

  ; Render the string
  copy r0, num
  set16 r1, strbuf
  call convertString

  ; Run the output loop
  copy buf, r1     ; buf = start of string
  copy r1, handle  ; this can sit here and be reused for each invocation of outputByte
  ba :++           ; a little loop entry optimization
:  call outputByte
   addi4 buf, 1
:  ldmb r0, buf
  bnz :--
  rets 3

strbuf: .res 6
.endproc

;--------------------
.proc outputByte
; in: r0=byte, r1=handle (points to a cursor pointer for now)

  grow 1
  cursor = r0
  byte   = r1
  handle = r2

  ; Dereference the handle to get the cursor pointer
  ldm cursor, handle

.if 1
  ; Longer but potentially slightly faster, by chaining rP.  Have to explicitly "with" to get it started since the incoming rP is cursor, not byte
  with byte
  stpmb cursor
  addp 1
.else
  ; Shorter but potentially slightly slower, by directly addressing needed registers
  stmb byte, cursor
  addi cursor, 1
.endif

  stpm handle  ; keep the handle's value updated
  rets 1
.endproc

